Overview | Package | Class | Tree | Deprecated | Index | Help
| Oracle Application Development Framework Model and Business Components Java API Reference 10g Release 3 (10.1.3) B16005-01
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## oracle.jbo.client.remote
Class TransPostEntityRow

`java.lang.Object
oracle.jbo.client.remote.TransPostEntityRow`

All Implemented Interfaces:
  AttributeList, Row, XMLInterface

public class TransPostEntityRow
extends java.lang.Object
implements Row

Field Summary

Fields inherited from interface oracle.jbo.Row
`REFRESH_CONTAINEES, REFRESH_FORGET_NEW_ROWS, REFRESH_REMOVE_NEW_ROWS, REFRESH_UNDO_CHANGES, REFRESH_WITH_DB_FORGET_CHANGES, REFRESH_WITH_DB_ONLY_IF_UNCHANGED, STATUS_INITIALIZED, STATUS_NEW`

Fields inherited from interface oracle.jbo.XMLInterface
`XML_IGNORE_DEPTH_COUNT, XML_OPT_ALL_ROWS, XML_OPT_ASSOC_CONSISTENT, XML_OPT_CHANGES_ONLY, XML_OPT_LIMIT_RANGE`

Method Summary
`java.lang.Object` | `getAttribute(int index)` Selects the attribute at the given index.
`java.lang.Object` | `getAttribute(java.lang.String name)` Selects the attribute with the given name.
`int` | `getAttributeCount()` Counts the number of attributes.
`int` | `getAttributeIndexOf(java.lang.String name)` Finds the index (0-based) of the named attribute.
`java.lang.String[]` | `getAttributeNames()` Returns an array of attribute names in this list.
`java.lang.Object[]` | `getAttributeValues()` Returns an array of attribute values in this list.
`Key` | `getKey()` Returns the row's key.
`StructureDef` | `getStructureDef()` Returns the structure of the row.
`boolean` | `isAttributeUpdateable(int index)` Tests if an attribute is updateable.
`boolean` | `isDead()` An attempt to access a dead view row will lead to a DeadViewRowAccessException.
`void` | `lock()` Locks the row(s) in the database table.
`void` | `readXML(Element elem, int depthCount)`
`void` | `readXML(Element elem, int depthCount, XSLStylesheet xslt)`
`void` | `refresh(int refreshMode)` Refreshes the row's attributes with values from database.
`void` | `remove()` Removes the row from the database table.
`void` | `removeAndRetain()` Removes the row from the collection and then retain it for insertion into another location.
`void` | `removeFromCollection()` Removes the row from the collection.
`void` | `setAttribute(int index, java.lang.Object value)` Sets the value of an attribute.
`void` | `setAttribute(java.lang.String name, java.lang.Object value)` Set the value for the named attribute.
`void` | `setNewRowState(byte state)` Sets a new unposted row, created in this transaction, to either STATUS_NEW or STATUS_INITIALIZED mode.
`void` | `validate()` Validates the row.
`Node` | `writeXML(int depthCount, long options)` Renders data in a canonical XML-format.
`Node` | `writeXML(int depthCount, long options, XSLStylesheet xslt)`
`Node` | `writeXML(long options, com.sun.java.util.collections.HashMap voAttrMap)` Renders data in a canonical XML-format.
`Node` | `writeXML(long options, com.sun.java.util.collections.HashMap voAttrMap, XSLStylesheet xslt)`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Method Detail

### getKey

    public Key getKey()

  Description copied from interface: `Row`
  Returns the row's key.
  Specified by:
    `getKey` in interface `Row`
  Returns:
    the row's Key.

### validate

    public void validate()

  Description copied from interface: `Row`
  Validates the row. The default implementation of this method on a View row calls `validate()` for each Entity row that makes up the View row.
  Specified by:
    `validate` in interface `Row`
  See Also:
    `EntityImpl.validate()`, `ViewRowImpl.validate()`

### lock

    public void lock()

  Description copied from interface: `Row`
  Locks the row(s) in the database table.

  For a View row, this method calls `lock()` on each Entity row that makes up the View row.

  Specified by:
    `lock` in interface `Row`

### remove

    public void remove()

  Description copied from interface: `Row`
  Removes the row from the database table.

  If this method is invoked on a View row or an Entity row, and if the current concurrency control mode is ``Transaction.LOCK_PESSIMISTIC``, this method first locks the Entity row(s), and then removes the Entity row(s). Thus, this method may throw the same exceptions as ``Row.lock()`` method.

  Specified by:
    `remove` in interface `Row`

### removeFromCollection

    public void removeFromCollection()

  Description copied from interface: `Row`
  Removes the row from the collection.

  This method differs from ``Row.remove()`` in that it just removes the row from the collection. It does not remove the underlying Entity row(s) or database row(s). However, once the row is removed, it cannot be used any more. If you want to remove the row from the collection and insert it elsewhere, call ``Row.removeAndRetain()``.

  Specified by:
    `removeFromCollection` in interface `Row`

### removeAndRetain

    public void removeAndRetain()

  Description copied from interface: `Row`
  Removes the row from the collection and then retain it for insertion into another location.

  This method differs from ``Row.remove()`` in that it just removes the row from the collection. It does not remove the underlying Entity row(s) or database row(s).

  This method also differs from ``Row.removeFromCollection()`` in that after the row is removed from the collection, it can be inserted back into the collection at another location.

  Specified by:
    `removeAndRetain` in interface `Row`

### refresh

    public void refresh(int refreshMode)

  Description copied from interface: `Row`
  Refreshes the row's attributes with values from database. `refreshMode` should be a combination of `REFRESH_...`. See `REFRESH_...` constants for further information.
  Specified by:
    `refresh` in interface `Row`
  Parameters:
    `refreshMode` - the refresh mode.

### isAttributeUpdateable

    public boolean isAttributeUpdateable(int index)

  Description copied from interface: `Row`
  Tests if an attribute is updateable. Returns `false` if the attribute is read-only and `true` if it is updateable.

  The following logic is used for determining if the attribute is updateable. If this attribute for a View row and is one which is mapped to an Entity Attribute, and if the Entity base is marked as read-only in the View Object, the attribute is read-only.

  If the Entity base is marked updateable, a check is made to see if the the current user has updateable privilege on the underlying Entity row. If not, the attribute is read-only.

  After this, we check the View Object's Attribute Definition. If the Attribute Definition indicates that it is `READONLY`, this method returns `false` (read-only). If the Attribute Definition says `UPDATEABLE`, it drops to the Entity level to determine if the Entity level Attribute Definition says it is updateable. If the attribute is `UPDATEABLE_WHILE_NEW` We check to see if the 'row' is new or not. (If this attribute comes from an Entity Row, the 'row' is the Entity Row. Otherwise, the 'row' is the View Row.) If the row is new, the attribute is updateable.

  Specified by:
    `isAttributeUpdateable` in interface `Row`
  Parameters:
    `index` - the index of the attribute.
  Returns:
    `true` if the attribute is updateable in this row. `false` if not.

### isDead

    public boolean isDead()

  Description copied from interface: `Row`
  An attempt to access a dead view row will lead to a DeadViewRowAccessException. Using this API method, client code can test the row state.
  Specified by:
    `isDead` in interface `Row`
  Returns:
    `true` if the row is dead.

### setNewRowState

    public void setNewRowState(byte state)

  Description copied from interface: `Row`
  Sets a new unposted row, created in this transaction, to either STATUS_NEW or STATUS_INITIALIZED mode. Calling this method on a row in any other state will be a no-op.

  This method should be used to create a row and then to mark it temporary (STATUS_INITIALIZED) so that an app can use the created Row to fill UIs like Table UIs with valid default values for rows. Then when the Row values are updated, UIs should once again call this method to turn the Row into new (STATUS_NEW) state before any setAttribute calls on the Row, so that the changes are validated and posted.

  When a created row is in STATUS_NEW (by default) state and this method is called to turn the row in to STATUS_INITIALIZED, all updateable entities that this row comprises of, de=registers themselves from their respective transaction and validation managers. Assocation and ViewLink finders will not find/include these rows. Only the collection into which this row was inserted into will contain a reference to this row and when that collection is re-executed this row cannot be reached via the framework. To include this row again an app should call this method again with STATUS_NEW as the method-argument

  When this row is in STATUS_INITIALIZED state and this method is called with STATUS_NEW state then, this new row is added back into it's relevant transaction and validation manager and will then participate in validation, transaction cycles.

  Note that incase of composition if a master/detail hierarchy is being created with the intention of making them temporary (STATUS_INITIALIZED) then the logic should be: Create Master row, insert Master row into a collection, create Detail row insert detail row into a relevant collection, make detail row initialized, create/insert/change-to-initialized more detail rows and at the end set the master row as initialized.

  Specified by:
    `setNewRowState` in interface `Row`
  Parameters:
    `state` - This could be STATUS_NEW or STATUS_INITIALIZED.

### getStructureDef

    public StructureDef getStructureDef()

  Description copied from interface: `Row`
  Returns the structure of the row.
  Specified by:
    `getStructureDef` in interface `Row`
  Returns:
    `StructureDef` that describes the structure of the row.

### getAttribute

    public java.lang.Object getAttribute(int index)

  Description copied from interface: `AttributeList`
  Selects the attribute at the given index.
  Specified by:
    `getAttribute` in interface `AttributeList`
  Parameters:
    `index` - an integer in the range `0` to `getAttributeCount() - 1`.
  Returns:
    the attribute associated with `index`.

### getAttribute

    public java.lang.Object getAttribute(java.lang.String name)

  Description copied from interface: `AttributeList`
  Selects the attribute with the given name.
  Specified by:
    `getAttribute` in interface `AttributeList`
  Parameters:
    `name` - an attribute name.
  Returns:
    the attribute associated with `name`.

### setAttribute

    public void setAttribute(int index,
                             java.lang.Object value)

  Description copied from interface: `AttributeList`
  Sets the value of an attribute.
  Specified by:
    `setAttribute` in interface `AttributeList`
  Parameters:
    `index` - the attribute's index.
    `value` - the value to be assigned to the attribute.

### setAttribute

    public void setAttribute(java.lang.String name,
                             java.lang.Object value)

  Description copied from interface: `AttributeList`
  Set the value for the named attribute.
  Specified by:
    `setAttribute` in interface `AttributeList`
  Parameters:
    `name` - the attribute's name.
    `value` - the value to be assigned to the attribute.

### getAttributeCount

    public int getAttributeCount()

  Description copied from interface: `AttributeList`
  Counts the number of attributes.
  Specified by:
    `getAttributeCount` in interface `AttributeList`
  Returns:
    the number of attributes.

### getAttributeIndexOf

    public int getAttributeIndexOf(java.lang.String name)

  Description copied from interface: `AttributeList`
  Finds the index (0-based) of the named attribute.
  Specified by:
    `getAttributeIndexOf` in interface `AttributeList`
  Parameters:
    `name` - the attribute's name.
  Returns:
    an integer in the range `0` to `getAttributeCount() - 1`. If the named attribute is not found, it returns -1.

### getAttributeNames

    public java.lang.String[] getAttributeNames()

  Description copied from interface: `AttributeList`
  Returns an array of attribute names in this list.
  Specified by:
    `getAttributeNames` in interface `AttributeList`
  Returns:
    an array of attribute names.

### getAttributeValues

    public java.lang.Object[] getAttributeValues()

  Description copied from interface: `AttributeList`
  Returns an array of attribute values in this list.
  Specified by:
    `getAttributeValues` in interface `AttributeList`
  Returns:
    an array of attribute values.

### writeXML

    public Node writeXML(long options,
                         com.sun.java.util.collections.HashMap voAttrMap)

  Description copied from interface: `XMLInterface`
  Renders data in a canonical XML-format. The classes `ViewObjectImpl` and `ViewRowImpl` implement this method to render data in XML.

  Use this method whenever data is required in XML format, either to present a UI (after converting XML data into some HTTP format using a stylesheet) or to pass the data as payload for messages via JMS.

  The `options` parameter represents a set of bit flags that will control the `writeXML` behavior. The following bit flags have been defined:

  - `public static long XML_OPT_LIMIT_RANGE = 0x00000001` - Controls whether `writeXML` will only write rows in the range. If this flag is off, all rows in the row set will be written. If this flag is on, only rows in the current range will be written.
  - `public static long XML_OPT_CHANGES_ONLY = 0x00000002` - Controls whether only changed attribute values of an entity row is written. If this is on, only the attributes whose value has been marked as "changed" will be written. If this is off, all attributes (regardless of whether the attribute value has been changed or not) will be written. This flag is relevant only when writing `EntityImpl`.

  The `voAttrMap` parameter represents in a hashmap, the mapping between a given ViewObject's definition type and the corresponding Attributes/accessors to render. A null entry in the hashmap means, render all attributes and accessors of that viewobject type.

  Specified by:
    `writeXML` in interface `XMLInterface`
  Parameters:
    `options` - a set of bit flags that will control the `writeXML`
    `voAttrMap` - HashMap containing Definition names of ViewObjects and an array of AttributeDef to render for a ViewObject of that definition type.

### writeXML

    public Node writeXML(long options,
                         com.sun.java.util.collections.HashMap voAttrMap,
                         XSLStylesheet xslt)

  Specified by:
    `writeXML` in interface `XMLInterface`

### writeXML

    public Node writeXML(int depthCount,
                         long options)

  Description copied from interface: `XMLInterface`
  Renders data in a canonical XML-format. The classes `ViewObjectImpl` and `ViewRowImpl` implement this method to render data in XML.

  Use this method whenever data is required in XML format, either to present a UI (after converting XML data into some HTTP format using a stylesheet) or to pass the data as payload for messages via JMS.

  The `depthcount` parameter represents to what level the rendering should recurse. A `depthcount` of zero (0) means do not traverse any View Links while rendering. One (1) means traverse the View Links on this object but no View Links thereafter, and so on.

  The `options` parameter represents a set of bit flags that will control the `writeXML` behavior. The following bit flags have been defined:

  - `public static long XML_OPT_LIMIT_RANGE = 0x00000001` - Controls whether `writeXML` will only write rows in the range. If this flag is off, all rows in the row set will be written. If this flag is on, only rows in the current range will be written.
  - `public static long XML_OPT_CHANGES_ONLY = 0x00000002` - Controls whether only changed attribute values of an entity row is written. If this is on, only the attributes whose value has been marked as "changed" will be written. If this is off, all attributes (regardless of whether the attribute value has been changed or not) will be written. This flag is relevant only when writing `EntityImpl`.
  Specified by:
    `writeXML` in interface `XMLInterface`
  Parameters:
    `depthCount` - represents to what level the rendering should recurse.
    `options` - a set of bit flags that will control the `writeXML` behavior.

### readXML

    public void readXML(Element elem,
                        int depthCount)

  Specified by:
    `readXML` in interface `XMLInterface`

### writeXML

    public Node writeXML(int depthCount,
                         long options,
                         XSLStylesheet xslt)

  Specified by:
    `writeXML` in interface `XMLInterface`

### readXML

    public void readXML(Element elem,
                        int depthCount,
                        XSLStylesheet xslt)

  Specified by:
    `readXML` in interface `XMLInterface`

Overview | Package | Class | Tree | Deprecated | Index | Help
| Oracle Application Development Framework Model and Business Components Java API Reference 10g Release 3 (10.1.3) B16005-01
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 1997, 2005, Oracle. All rights reserved.